'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _FlexiGridRow = require('./FlexiGridRow');

var _FlexiGridRow2 = _interopRequireDefault(_FlexiGridRow);

var _FlexiGridRowBuffer = require('./FlexiGridRowBuffer');

var _FlexiGridRowBuffer2 = _interopRequireDefault(_FlexiGridRowBuffer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlexiGridBufferedColumns = function (_React$Component) {
  (0, _inherits3.default)(FlexiGridBufferedColumns, _React$Component);

  function FlexiGridBufferedColumns(props) {
    (0, _classCallCheck3.default)(this, FlexiGridBufferedColumns);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FlexiGridBufferedColumns.__proto__ || (0, _getPrototypeOf2.default)(FlexiGridBufferedColumns)).call(this, props));

    _this.getRowHeight = function (index) {
      return _this.props.getRowHeight ? _this.props.getRowHeight(index) : _this.props.defaultRowHeight;
    };

    _this.getSubRowHeight = function (index) {
      return _this.props.getSubRowHeight ? _this.props.getSubRowHeight(index) : _this.props.subRowHeight;
    };

    _this.rowBuffer = new _FlexiGridRowBuffer2.default(_this.props.rowCount, _this.props.defaultRowHeight, _this.props.height, _this.getRowHeight, _this.props.bufferRowCount);

    _this.state = {
      rowsToRender: _this.rowBuffer.getRows(_this.props.firstRowIndex, _this.props.firstRowOffset)
    };
    return _this;
  }

  (0, _createClass3.default)(FlexiGridBufferedColumns, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      setTimeout(this.updateBuffer, 1000);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.rowCount !== this.props.rowCount || nextProps.defaultRowHeight !== this.props.defaultRowHeight || nextProps.height !== this.props.height) {
        this.rowBuffer = new _FlexiGridRowBuffer2.default(nextProps.rowCount, nextProps.defaultRowHeight, nextProps.height, this.getRowHeight, this.props.bufferRowCount);
      }

      if (this.props.scrolling && !nextProps.scrolling) {
        this.updateBuffer();
      } else {
        this.setState({
          rowsToRender: this.rowBuffer.getRows(nextProps.firstRowIndex, nextProps.firstRowOffset)
        });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      return true;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.rowBuffer = null;
    }
  }, {
    key: 'updateBuffer',
    value: function updateBuffer() {
      if (this.rowBuffer) {
        this.setState({
          rowsToRender: this.rowBuffer.getRowsWithUpdatedBuffer()
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          data = _props.data,
          rowKey = _props.rowKey,
          firstRowIndex = _props.firstRowIndex,
          firstRowOffset = _props.firstRowOffset,
          bufferRowCount = _props.bufferRowCount,
          scrolling = _props.scrolling,
          getRowPosition = _props.getRowPosition,
          getRowClassName = _props.getRowClassName,
          getRowHeight = _props.getRowHeight,
          getSubRowHeight = _props.getSubRowHeight,
          otherProps = (0, _objectWithoutProperties3.default)(_props, ['data', 'rowKey', 'firstRowIndex', 'firstRowOffset', 'bufferRowCount', 'scrolling', 'getRowPosition', 'getRowClassName', 'getRowHeight', 'getSubRowHeight']);


      var rowsToRender = this.state.rowsToRender;
      var baseOffsetTop = firstRowOffset - getRowPosition(firstRowIndex);
      var rowPositions = {};
      var sortedRows = rowsToRender.slice().sort(function (a, b) {
        return a - b;
      });

      sortedRows.forEach(function (rowIndex) {
        rowPositions[rowIndex] = getRowPosition(rowIndex);
      });

      var staticRowArray = rowsToRender.map(function (rowIndex) {
        var currentRowHeight = _this2.getRowHeight(rowIndex);
        // const currentSubRowHeight = this.getSubRowHeight(rowIndex)
        var rowOffsetTop = baseOffsetTop + rowPositions[rowIndex];
        var className = getRowClassName ? getRowClassName(rowIndex) : null;
        var record = data[rowIndex];
        var rowProps = (0, _extends3.default)({}, otherProps, {
          className: className,
          rowIndex: rowIndex,
          record: record,
          height: currentRowHeight,
          offsetTop: Math.round(rowOffsetTop)
        });
        return _react2.default.createElement(_FlexiGridRow2.default, (0, _extends3.default)({ key: 'body-row-' + record[rowKey] }, rowProps));
      });

      return _react2.default.createElement(
        'div',
        null,
        staticRowArray
      );
    }
  }]);
  return FlexiGridBufferedColumns;
}(_react2.default.Component);

FlexiGridBufferedColumns.PROPTYPES_DISABLED_FOR_PERFORMANCE = {
  // inherit from body
  prefixCls: _propTypes2.default.string,
  rowHeight: _propTypes2.default.number,
  bordered: _propTypes2.default.bool,
  scrollX: _propTypes2.default.number,
  showScrollbarX: _propTypes2.default.bool,
  showScrollbarY: _propTypes2.default.bool,

  leftFixedColumns: _propTypes4.default.columns,
  scrollableColumns: _propTypes4.default.columns,
  rightFixedColumns: _propTypes4.default.columns,
  leftFixedLeafColumns: _propTypes4.default.columns,
  scrollableLeafColumns: _propTypes4.default.columns,
  rightFixedLeafColumns: _propTypes4.default.columns,
  leftFixedColumnsWidth: _propTypes2.default.number,
  scrollableColumnsWidth: _propTypes2.default.number,
  rightFixedColumnsWidth: _propTypes2.default.number,
  leftFixedColumnsUpdated: _propTypes2.default.bool,
  scrollableColumnsUpdated: _propTypes2.default.bool,
  rightFixedColumnsUpdated: _propTypes2.default.bool,

  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  data: _propTypes4.default.data,
  rowKey: _propTypes4.default.columnKey,
  firstRowIndex: _propTypes2.default.number,
  firstRowOffset: _propTypes2.default.number,
  bufferRowCount: _propTypes2.default.number,
  scrolling: _propTypes2.default.bool,
  getRowPosition: _propTypes2.default.func.isRequired,
  getRowClassName: _propTypes2.default.func,
  getRowHeight: _propTypes2.default.func,
  getSubRowHeight: _propTypes2.default.func,

  onRowTouchStart: _propTypes2.default.func,
  onRowTouchEnd: _propTypes2.default.func,
  onRowTouchMove: _propTypes2.default.func,

  onRowClick: _propTypes2.default.func,
  onRowDoubleClick: _propTypes2.default.func,
  onRowMouseDown: _propTypes2.default.func,
  onRowMouseUp: _propTypes2.default.func,
  onRowMouseEnter: _propTypes2.default.func,
  onRowMouseLeave: _propTypes2.default.func,

  // specified
  rowCount: _propTypes2.default.number,
  defaultRowHeight: _propTypes2.default.number
};
exports.default = FlexiGridBufferedColumns;
module.exports = exports['default'];