'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlexiGridCell = function (_React$Component) {
  (0, _inherits3.default)(FlexiGridCell, _React$Component);

  function FlexiGridCell() {
    (0, _classCallCheck3.default)(this, FlexiGridCell);
    return (0, _possibleConstructorReturn3.default)(this, (FlexiGridCell.__proto__ || (0, _getPrototypeOf2.default)(FlexiGridCell)).apply(this, arguments));
  }

  (0, _createClass3.default)(FlexiGridCell, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return !(0, _utils.shallowEqual)(this.props, nextProps);
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          height = _props.height,
          width = _props.width,
          dataIndex = _props.dataIndex,
          rowIndex = _props.rowIndex,
          record = _props.record,
          render = _props.render;


      var content = record && record[dataIndex];
      if (render) {
        if (_react2.default.isValidElement(render)) {
          content = _react2.default.cloneElement(render, {
            record: record,
            dataIndex: dataIndex,
            rowIndex: rowIndex
          });
        } else if (typeof render === 'function') {
          content = render(content, record, rowIndex);
        } else {
          content = render;
        }
      }

      return _react2.default.createElement(
        'div',
        { className: prefixCls + '-cell-wrap1', style: { width: width, height: height } },
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-cell-wrap2' },
          _react2.default.createElement(
            'div',
            { className: prefixCls + '-cell-wrap3' },
            _react2.default.createElement(
              'div',
              { className: prefixCls + '-cell-content', style: { width: width } },
              content
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames;

      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          className = _props2.className,
          align = _props2.align,
          width = _props2.width,
          height = _props2.height,
          left = _props2.left;

      var cls = (0, _classnames2.default)((_classNames = {}, (0, _defineProperty3.default)(_classNames, prefixCls + '-cell', true), (0, _defineProperty3.default)(_classNames, 'align-left', align === 'left' || align === undefined), (0, _defineProperty3.default)(_classNames, 'align-center', align === 'center'), (0, _defineProperty3.default)(_classNames, 'align-right', align === 'right'), _classNames), className);

      return _react2.default.createElement(
        'div',
        { className: cls, style: { width: width, height: height, left: left } },
        this.renderContent()
      );
    }
  }]);
  return FlexiGridCell;
}(_react2.default.Component);

FlexiGridCell.PROPTYPES_DISABLED_FOR_PERFORMANCE = {
  prefixCls: _propTypes2.default.string,
  className: _propTypes4.default.className,
  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number.isRequired,
  minWidth: _propTypes2.default.number,
  maxWidth: _propTypes2.default.number,
  left: _propTypes2.default.number,
  align: _propTypes4.default.align,
  rowIndex: _propTypes2.default.number.isRequired,
  dataIndex: _propTypes4.default.columnKey,
  render: _propTypes4.default.render,
  record: _propTypes4.default.record
};
exports.default = FlexiGridCell;
module.exports = exports['default'];