'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _utils = require('./utils');

var _FlexiGridUpdateHelper = require('./FlexiGridUpdateHelper');

var _FlexiGridCellGroup = require('./FlexiGridCellGroup');

var _FlexiGridCellGroup2 = _interopRequireDefault(_FlexiGridCellGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlexiGridRow = function (_React$Component) {
  (0, _inherits3.default)(FlexiGridRow, _React$Component);

  function FlexiGridRow() {
    (0, _classCallCheck3.default)(this, FlexiGridRow);
    return (0, _possibleConstructorReturn3.default)(this, (FlexiGridRow.__proto__ || (0, _getPrototypeOf2.default)(FlexiGridRow)).apply(this, arguments));
  }

  (0, _createClass3.default)(FlexiGridRow, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.initialRender = true;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initialRender = false;
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return (0, _FlexiGridUpdateHelper.shouldUpdateRow)(this.props, nextProps);
    }
  }, {
    key: 'renderLeftFixedColumns',
    value: function renderLeftFixedColumns() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          record = _props.record,
          height = _props.height,
          rowHeight = _props.rowHeight,
          rowIndex = _props.rowIndex,
          isHeader = _props.isHeader,
          leftFixedColumns = _props.leftFixedColumns,
          leftFixedLeafColumns = _props.leftFixedLeafColumns,
          leftFixedColumnsWidth = _props.leftFixedColumnsWidth,
          leftFixedColumnsUpdated = _props.leftFixedColumnsUpdated;


      var props = {
        record: record,
        prefixCls: prefixCls,
        className: 'fixed-left',
        width: leftFixedColumnsWidth,
        height: height,
        rowHeight: rowHeight,
        rowIndex: rowIndex,
        isHeader: isHeader,
        left: 0,
        zIndex: 1,
        columns: leftFixedColumns,
        leafColumns: leftFixedLeafColumns,
        columnsUpdated: leftFixedColumnsUpdated
      };

      return _react2.default.createElement(_FlexiGridCellGroup2.default, (0, _extends3.default)({ key: 'left-fixed-columns' }, props));
    }
  }, {
    key: 'renderScrollableColumns',
    value: function renderScrollableColumns() {
      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          record = _props2.record,
          height = _props2.height,
          rowHeight = _props2.rowHeight,
          rowIndex = _props2.rowIndex,
          isHeader = _props2.isHeader,
          bordered = _props2.bordered,
          scrollX = _props2.scrollX,
          showScrollbarX = _props2.showScrollbarX,
          getColumnPosition = _props2.getColumnPosition,
          scrollableColumns = _props2.scrollableColumns,
          rightFixedColumns = _props2.rightFixedColumns,
          scrollableLeafColumns = _props2.scrollableLeafColumns,
          scrollableColumnsToRender = _props2.scrollableColumnsToRender,
          scrollableLeafColumnsToRender = _props2.scrollableLeafColumnsToRender,
          leftFixedColumnsWidth = _props2.leftFixedColumnsWidth,
          scrollableColumnsWidth = _props2.scrollableColumnsWidth,
          scrollableColumnsUpdated = _props2.scrollableColumnsUpdated,
          scrollableColumnsToRenderUpdated = _props2.scrollableColumnsToRenderUpdated;


      var props = {
        prefixCls: prefixCls,
        record: record,
        className: 'scrollable',
        width: scrollableColumnsWidth,
        height: height,
        rowHeight: rowHeight,
        rowIndex: rowIndex,
        isHeader: isHeader,
        scrollX: scrollX,
        left: leftFixedColumnsWidth,
        getColumnPosition: getColumnPosition,
        columns: scrollableColumns,
        leafColumns: scrollableLeafColumns,
        columnsUpdated: scrollableColumnsUpdated,
        columnsToRender: scrollableColumnsToRender,
        leafColumnsToRender: scrollableLeafColumnsToRender,
        columnsToRenderUpdated: scrollableColumnsToRenderUpdated,
        fixLastColumn: bordered && showScrollbarX && rightFixedColumns.length === 0
      };

      return _react2.default.createElement(_FlexiGridCellGroup2.default, (0, _extends3.default)({ key: 'scrollable-columns' }, props));
    }
  }, {
    key: 'renderRightFixedColumns',
    value: function renderRightFixedColumns() {
      var _props3 = this.props,
          prefixCls = _props3.prefixCls,
          record = _props3.record,
          width = _props3.width,
          height = _props3.height,
          rowHeight = _props3.rowHeight,
          rowIndex = _props3.rowIndex,
          isHeader = _props3.isHeader,
          bordered = _props3.bordered,
          showScrollbarX = _props3.showScrollbarX,
          showScrollbarY = _props3.showScrollbarY,
          scrollbarSize = _props3.scrollbarSize,
          rightFixedColumns = _props3.rightFixedColumns,
          rightFixedLeafColumns = _props3.rightFixedLeafColumns,
          leftFixedColumnsWidth = _props3.leftFixedColumnsWidth,
          scrollableColumnsWidth = _props3.scrollableColumnsWidth,
          rightFixedColumnsWidth = _props3.rightFixedColumnsWidth,
          rightFixedColumnsUpdated = _props3.rightFixedColumnsUpdated;


      var props = {
        prefixCls: prefixCls,
        record: record,
        className: 'fixed-right',
        width: rightFixedColumnsWidth,
        height: height,
        rowHeight: rowHeight,
        rowIndex: rowIndex,
        isHeader: isHeader,
        zIndex: 1,
        columns: rightFixedColumns,
        leafColumns: rightFixedLeafColumns,
        columnsUpdated: rightFixedColumnsUpdated,
        fixLastColumn: bordered && showScrollbarX
      };

      var leftGroupsWidth = leftFixedColumnsWidth + scrollableColumnsWidth;
      if (leftGroupsWidth + props.width > width) {
        props.left = width - props.width;
      } else {
        props.left = leftGroupsWidth;
      }

      if (isHeader && showScrollbarX && showScrollbarY) {
        props.width += scrollbarSize;
        props.left -= scrollbarSize;
      }

      return _react2.default.createElement(_FlexiGridCellGroup2.default, (0, _extends3.default)({ key: 'right-fixed-columns' }, props));
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames;

      var _props4 = this.props,
          prefixCls = _props4.prefixCls,
          width = _props4.width,
          height = _props4.height,
          offsetTop = _props4.offsetTop,
          rowIndex = _props4.rowIndex,
          isHeader = _props4.isHeader;

      var wrapStyle = { width: width, height: height };
      var innerStyle = { width: width, height: height };

      (0, _utils.translateDOMPosition)(wrapStyle, 0, offsetTop, this.initialRender);

      var className = (0, _classnames2.default)((_classNames = {}, (0, _defineProperty3.default)(_classNames, prefixCls + '-row', true), (0, _defineProperty3.default)(_classNames, 'is-header', isHeader), (0, _defineProperty3.default)(_classNames, 'odd', !isHeader && rowIndex % 2 === 1), (0, _defineProperty3.default)(_classNames, 'even', !isHeader && rowIndex % 2 === 0), _classNames));

      return _react2.default.createElement(
        'div',
        { className: prefixCls + '-row-wrap', style: wrapStyle },
        _react2.default.createElement(
          'div',
          { className: className, style: innerStyle },
          this.props.leftFixedColumns.length && this.renderLeftFixedColumns(),
          this.props.scrollableColumns.length && this.renderScrollableColumns(),
          this.props.rightFixedColumns.length && this.renderRightFixedColumns()
        )
      );
    }
  }]);
  return FlexiGridRow;
}(_react2.default.Component);

FlexiGridRow.PROPTYPES_DISABLED_FOR_PERFORMANCE = {
  prefixCls: _propTypes2.default.string,
  className: _propTypes2.default.string,
  record: _propTypes4.default.record,
  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  offsetTop: _propTypes2.default.number,
  isHeader: _propTypes2.default.bool,
  rowIndex: _propTypes2.default.number,
  rowHeight: _propTypes2.default.number,
  bordered: _propTypes2.default.bool,
  scrollX: _propTypes2.default.number,
  showScrollbarX: _propTypes2.default.bool,
  showScrollbarY: _propTypes2.default.bool,
  scrollbarSize: _propTypes2.default.number,

  leftFixedColumns: _propTypes4.default.columns,
  scrollableColumns: _propTypes4.default.columns,
  rightFixedColumns: _propTypes4.default.columns,
  leftFixedLeafColumns: _propTypes4.default.columns,
  scrollableLeafColumns: _propTypes4.default.columns,
  rightFixedLeafColumns: _propTypes4.default.columns,
  scrollableColumnsToRender: _propTypes4.default.columns,
  scrollableLeafColumnsToRender: _propTypes4.default.columns,
  leftFixedColumnsWidth: _propTypes2.default.number,
  scrollableColumnsWidth: _propTypes2.default.number,
  rightFixedColumnsWidth: _propTypes2.default.number,
  leftFixedColumnsUpdated: _propTypes2.default.bool,
  scrollableColumnsUpdated: _propTypes2.default.bool,
  rightFixedColumnsUpdated: _propTypes2.default.bool,
  scrollableColumnsToRenderUpdated: _propTypes2.default.bool,

  onRowTouchStart: _propTypes2.default.func,
  onRowTouchEnd: _propTypes2.default.func,
  onRowTouchMove: _propTypes2.default.func,

  onRowClick: _propTypes2.default.func,
  onRowDoubleClick: _propTypes2.default.func,
  onRowMouseDown: _propTypes2.default.func,
  onRowMouseUp: _propTypes2.default.func,
  onRowMouseEnter: _propTypes2.default.func,
  onRowMouseLeave: _propTypes2.default.func
};
exports.default = FlexiGridRow;
module.exports = exports['default'];